#!/bin/sh
# $Id: evolvotron.SlackBuild,v 1.9 2019/05/31 09:47:08 root Exp root $
# Copyright 2006, 2008, 2010, 2011, 2013, 2019  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:         Eric Hameleers <alien@slackware.com>
# For:        evolvotron
# Descr:      Generative art image evolver
# URL:        http://www.bottlenose.demon.co.uk/share/evolvotron/
# Needs:      boost
# Changelog:  
# 0.4.0-1:    09/mrt/2006 by Eric Hameleers <alien@slackware.com>
#             * Initial build.
# 0.5.1-1:    02/feb/2008 by Eric Hameleers <alien@slackware.com>
#             * New release.
# r647-1:     30/jan/2010 by Eric Hameleers <alien@slackware.com>
#             * New release.
# r647-2:     17/mar/2011 by Eric Hameleers <alien@slackware.com>
#             * Rebuilt for Slackware 13.37.
# 0.6.3-1:    08/feb/2013 by Eric Hameleers <alien@slackware.com>
#             * New release.
# r706-1:     30/may/2019 by Eric Hameleers <alien@slackware.com>
#             * New release (0.7.2dev).
# 
# Run 'sh evolvotron.SlackBuild' to build a Slackware package.
# The package (.tgz) plus descriptive .txt file are created in /tmp .
# Install using 'installpkg'. 
#
# -----------------------------------------------------------------------------

# Set initial variables:

PRGNAM=evolvotron
#VERSION=${VERSION:-0.7.2}
VERSION=${VERSION:-r706}
BUILD=${BUILD:-1}
TAG=${TAG:-alien}

DOCS="BUGS CHANGES LICENSE README TODO USAGE VERSION evolvotron.html extras"

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
#SRCURL="http://downloads.sourceforge.net/${PRGNAM}/${PRGNAM}-${VERSION}.tar.gz"
SRCURL=""

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Automatically determine the architecture we're building on:
MARCH=$( uname -m )
if [ -z "$ARCH" ]; then
  case "$MARCH" in
    i?86)    export ARCH=i586 ;;
    armv7hl) export ARCH=$MARCH ;;
    arm*)    export ARCH=arm ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
    *)       export ARCH=$MARCH ;;
  esac
fi

case "$ARCH" in
  i486)      SLKCFLAGS="-O2 -march=i486 -mtune=i686"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  x86_64)    SLKCFLAGS="-O2 -fPIC"
             SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
             ;;
  armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  *)         SLKCFLAGS="-O2"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
esac

case "ARCH" in
    arm*)    TARGET=$ARCH-slackware-linux-gnueabi ;;
    *)       TARGET=$ARCH-slackware-linux ;;
esac

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
                          # remove old log files

# Use the src_checkout() function if no downloadable tarball exists.
# This function checks out sources from SVN/CVS and creates a tarball of them.
src_checkout() {
  # Param #1 : index in the SOURCE[] array.
  # Param #2 : full path to where SOURCE[$1] tarball should be created.
  # Determine the tarball extension:
  PEXT=$(echo "${2}" | sed -r -e 's/.*[^.].(tar.xz|tar.gz|tar.bz2|tgz).*/\1/')
  case "$PEXT" in
    "tar.xz") TARCOMP="J" ;;
    "tar.gz") TARCOMP="z" ;;
    "tgz") TARCOMP="z" ;;
    "tar.bz2") TARCOMP="j" ;;
    *) echo "Archive can only have extension 'tar.xz', '.tar.gz' '.tar.bz2' or '
.tgz'" ; exit 1 ;;
  esac
  case ${1} in
  0) # This example assumes a SVN checkout:
     if [ "$(echo ${VERSION}|cut -c1)" == 'r' ]; then # revision instead of date
       REV=$(echo ${VERSION} | cut -c2-)
     else
       REV="{${VERSION}}"
     fi
     mkdir $PRGNAM-${VERSION} \
       && cd $PRGNAM-${VERSION} \
       && svn checkout --revision $REV https://svn.code.sf.net/p/evolvotron/code/trunk . \
       && find . -type d -name '.svn' -depth | xargs rm -rf \
       && chown -R root:root . \
       && cd .. \
       && tar -${TARCOMP}cf ${2} $PRGNAM-${VERSION}
     rm -rf $PRGNAM-${VERSION}
     ;;
  *) # Do nothing
     ;;
  esac
}

# Source file availability:
if ! [ -f ${SOURCE} ]; then
  echo "Source '$(basename ${SOURCE})' not available yet..."
  # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
  [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename ${SOURCE})"
  if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
  if ! [ "x${SRCURL}" == "x" ]; then
    echo "Will download file to $(dirname $SOURCE)"
    wget --no-check-certificate -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
    if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
      echo "Fail to download '$(basename ${SOURCE})'. Aborting the build."
      mv -f "${SOURCE}" "${SOURCE}".FAIL
      exit 1
    fi
  else
    # Try if we have a SVN/CVS download routine for ${SOURCE}
    echo "Will checkout sources to $(dirname $SOURCE)"
    src_checkout 0 "${SOURCE}" 2>&1 > $OUTPUT/checkout-$(basename ${SOURCE}).log
  fi
  if [ ! -f "${SOURCE}" -o ! -s "${SOURCE}" ]; then
    echo "File '$(basename ${SOURCE})' not available. Aborting the build."
    exit 1
  fi
fi

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
tar -xvf ${SOURCE}
mv ${PRGNAM} ${PRGNAM}-${VERSION} 2>/dev/null || true
cd ${PRGNAM}-${VERSION}

cat $SRCDIR/patches/evolvotron-0.7.1_qt5_crash.patch | patch -p1 --verbose \
  2>&1 | tee $OUTPUT/patch-${PRGNAM}.log

chown -R root:root .
chmod -R u+w,go+r-w,a+X-s .

echo Building ...
# This avoids compiling a version number into .la files:
QTDIR=/usr/lib${LIBDIRSUFFIX}/qt5 ; export QTDIR

export LDFLAGS="$SLKLDFLAGS"
export CXXFLAGS="$SLKCFLAGS"
export CFLAGS="$SLKCFLAGS"
qmake-qt5 "VERSION_NUMBER=$(./VERSION)" main.pro 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
make 2>&1 | tee $OUTPUT/make-${PRGNAM}.log

# Install all the needed stuff to the package dir
mkdir -p $PKG/usr/bin
cp ./evolvotron/evolvotron $PKG/usr/bin
cp ./evolvotron_render/evolvotron_render $PKG/usr/bin
cp ./evolvotron_mutate/evolvotron_mutate $PKG/usr/bin

mkdir -p $PKG/usr/man/man1
cp man/man1/*.1 $PKG/usr/man/man1

# Add a .desktop file:
mkdir -p $PKG/usr/share/pixmaps
install -m0644 -o root -g root $SRCDIR/${PRGNAM}.png $PKG/usr/share/pixmaps/
mkdir -p $PKG/usr/share/applications
cat <<EOT > $PKG/usr/share/applications/${PRGNAM}.desktop
[Desktop Entry]
Encoding=UTF-8
GenericName=Interactive generative art software
SwallowExec=
Name=Evolvotron
MimeType=
Exec=evolvotron
Icon=evolvotron
TerminalOptions=
Path=
Type=Application
Terminal=0
Categories=Application;Graphics;
EOT

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Compress the man page(s):
if [ -d $PKG/usr/man ]; then
  find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
  for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
fi

# Strip binaries:
find $PKG | xargs file | grep -e "executable" -e "shared object" \
  | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
cat $SRCDIR/slack-required > $PKG/install/slack-required

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep

umask ${_UMASK_}

